"""
This does the full thing:  it views from the retina, through V1,
to pyramid detection, then sets a fact on.  It also has the planning in.
So, it does the commands that are activated. 
I haven't done a good range of error checking for planning or pictures.
It runs on a 4 chip spinnaker board with 3-1 neurons.
Set this in nealParams.py.
"""

#imports for PyNN
from pyNN.utility import get_script_args#, normalized_filename
#from neo.io import PyNNTextIO

#import for spike injection
import spynnaker_external_devices_plugin.pyNN as externaldevices
from spinnman.messages.eieio.eieio_prefix_type import EIEIOPrefixType

#imports for image reading
import numpy
from PIL import Image

#NEAL files and functions
from nealParams import *
from visionClass import visionArea
from maes import *
from parseClass import parseArea
from controlClass import controlArea
from cogmapClass import cogmap


SUB_POPULATION_SIZE	=	5			#size of sub population



def nealProjection(preNeurons,postNeurons, connectorList,inhExc):
    if simulator_name == 'spiNNaker':
        Projection(preNeurons, postNeurons, connectorList,target=inhExc)
    elif simulator_name == 'nest':
        Projection(preNeurons, postNeurons, connectorList)
    else:
        print 'bad simulator for nealProjection'

def runNoCallBack():
    run(SIM_LENGTH)

def connectVisionFactToPlanFact(visionFactNumber, planFactNumber):
    connector = []
    #wt = 4.0 mar9
    wt = 0.1
    for inpOffset in range (0,5):
        inpNeuron = inpOffset + visionFactNumber*5
        for toOffset in range (0,5):
            toNeuron = toOffset + (planFactNumber*5)
            connector = connector + [(inpNeuron,toNeuron,wt,DELAY)]
    return connector

def connectVisionFactToPlanFact2(weight, visionFactNumber, planFactNumber):
    connector = []
    for inpOffset in range (0,5):
        inpNeuron = inpOffset + visionFactNumber*5
        for toOffset in range (0,5):
            toNeuron = toOffset + (planFactNumber*5)
            connector = connector + [(inpNeuron,toNeuron,weight,DELAY)]
    connList = FromListConnector(connector)
    nealProjection(vision.getVisionFactCells(),maes1.getFactPop(),connList,
                   'excitatory')

def connectVisionToPlan():
    #coloured shapes to shape
    #shapeWt = 0.2 
    #shapeWt = 0.1
    shapeWt = 0.15
    connectVisionFactToPlanFact2(shapeWt,0,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,1,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,2,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,3,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,4,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,5,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,12,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,13,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,14,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,15,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,16,maes1.getFactIndex('SHAPE')) 
    connectVisionFactToPlanFact2(shapeWt,17,maes1.getFactIndex('SHAPE')) 

    #leftdoor to door
    connectVisionFactToPlanFact2(0.1,6,maes1.getFactIndex('DOOR')) 
    #leftdoor to left
    connectVisionFactToPlanFact2(0.3,6,maes1.getFactIndex('LEFT')) 
    #centredoor to door
    connectVisionFactToPlanFact2(0.1,8,maes1.getFactIndex('DOOR')) 
    #centredoor to centre
    connectVisionFactToPlanFact2(0.3,8,maes1.getFactIndex('CENTRE')) 
    #rightdoor to door
    connectVisionFactToPlanFact2(0.1,9,maes1.getFactIndex('DOOR')) 
    #rightdoor to right
    connectors= connectVisionFactToPlanFact2(0.3,9,maes1.getFactIndex('RIGHT')) 
    #endDoorCentre to enddoor
    connectVisionFactToPlanFact2(0.3,7,maes1.getFactIndex('ENDOOR')) 
    #endDoorCentre to door
    #connectVisionFactToPlanFact2(0.3,7,maes1.getFactIndex('DOOR')) 
    #endDoorCentre to centre
    #connectVisionFactToPlanFact2(0.3,7,maes1.getFactIndex('CENTRE')) 

    #undone change below to above calls

    #Connect Vision Facts to Plan Facts
    visionFactCells = vision.getVisionFactCells()
    #visionFactRightPyramid = vision.getRightPyramid()
    #visionFactLeftPyramid = vision.getLeftPyramid()
    #visionFactRightStalactite = vision.getRightStalactite()
    #visionFactLeftStalactite = vision.getLeftStalactite()
    maesFacts = maes1.getFactPop()
    #leftpyr to left
    connectors = connectVisionFactToPlanFact(0,maes1.getFactIndex('LEFT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightpyr to right
    connectors = connectVisionFactToPlanFact(1,maes1.getFactIndex('RIGHT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #leftpyr to pyr
    connectors = connectVisionFactToPlanFact(0,maes1.getFactIndex('PYR')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightpyr to pyr
    connectors = connectVisionFactToPlanFact(1,maes1.getFactIndex('PYR')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #leftstal to left
    connectors = connectVisionFactToPlanFact(2,maes1.getFactIndex('LEFT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #leftstal to stal
    connectors = connectVisionFactToPlanFact(2,maes1.getFactIndex('STAL')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightstal to right
    connectors = connectVisionFactToPlanFact(3,maes1.getFactIndex('RIGHT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightstal to stal
    connectors = connectVisionFactToPlanFact(3,maes1.getFactIndex('STAL')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centrepyr to pyr
    connectors = connectVisionFactToPlanFact(4,maes1.getFactIndex('PYR')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centrepyr to centre
    connectors = connectVisionFactToPlanFact(4,maes1.getFactIndex('CENTRE')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centrestal to stal
    connectors = connectVisionFactToPlanFact(5,maes1.getFactIndex('STAL')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centrestal to centre
    connectors = connectVisionFactToPlanFact(5,maes1.getFactIndex('CENTRE')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightdoor to right
    #connectors = connectVisionFactToPlanFact(9,maes1.getFactIndex('RIGHT')) 
    #connList = FromListConnector(connectors)
    #nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightdoor to door
    #connectors = connectVisionFactToPlanFact(9,maes1.getFactIndex('DOOR')) 
    #connList = FromListConnector(connectors)
    #nealProjection(visionFactCells,maesFacts,connList,'excitatory')



def connectParseResultToGoal(parseCells,goalCells,parseNumber,goalNumber):
    connectors = []
    wt = 10.0 #4chip
    for fromNeuron in range (0,5):
        inpNeuron = parseNumber*5 + fromNeuron
        for toNeuron in range (0,5):
            outNeuron = goalNumber*5 + toNeuron
            connectors = connectors + [(inpNeuron,outNeuron,wt,DELAY)]
    excConnector = FromListConnector(connectors)
    nealProjection(parseCells, goalCells, excConnector,'excitatory')

#Bump is sent by the environment to word 20.
#If that fires, turn the plan bump fact on.
def connectParseBumpToFact():
    parseBumpCells = parse.getBumpFromEnv()
    maesFactCells = maes1.getFactPop()
    bumpIndex=maes1.getFactIndex("BUMP")
    spbi = bumpIndex * SUB_POPULATION_SIZE
    wt = 25.0
    connectors=[]
    for toNeuron in range (0,5):
        outNeuron = spbi + toNeuron
        connectors = connectors + [(22,outNeuron,wt,DELAY)]
    excConnector = FromListConnector(connectors)
    nealProjection(parseBumpCells, maesFactCells, excConnector,'excitatory')

def connectParseToPlan():
    stateUnits = parse.getStates()
    goalUnits = maes1.getGoalCells()
    #turn left
    connectParseResultToGoal(stateUnits,goalUnits,3,maes1.getGoalIndex("TL")) 
    #turn right
    connectParseResultToGoal(stateUnits,goalUnits,5,maes1.getGoalIndex("TR")) 
    #move forward
    connectParseResultToGoal(stateUnits,goalUnits,14,maes1.getGoalIndex("FW")) 
    #move back
    connectParseResultToGoal(stateUnits,goalUnits,16,maes1.getGoalIndex("BW")) 
    #move left
    connectParseResultToGoal(stateUnits,goalUnits,18,maes1.getGoalIndex("ML1"))
    #move right
    connectParseResultToGoal(stateUnits,goalUnits,20,maes1.getGoalIndex("MR1"))
    #turn toward the pyramid
    connectParseResultToGoal(stateUnits,goalUnits,9,maes1.getGoalIndex("TP")) 
    #turn toward the stalac
    connectParseResultToGoal(stateUnits,goalUnits,11,maes1.getGoalIndex("TS"))
    #go to the barred pyram
    connectParseResultToGoal(stateUnits,goalUnits,49,maes1.getGoalIndex("GP"))
    #go to the barred stal
    connectParseResultToGoal(stateUnits,goalUnits,51,maes1.getGoalIndex("GS"))
    #go to the door
    connectParseResultToGoal(stateUnits,goalUnits,41,maes1.getGoalIndex("GD"))
    #explore
    connectParseResultToGoal(stateUnits,goalUnits,59,maes1.getGoalIndex("EXP"))
    #move before the blue pyramid
    connectParseResultToGoal(stateUnits,goalUnits,32,maes1.getGoalIndex("MBSTART"))
    #move before the red stal
    connectParseResultToGoal(stateUnits,goalUnits,25,maes1.getGoalIndex("MBSTART"))
    #move before the blue stal
    connectParseResultToGoal(stateUnits,goalUnits,28,maes1.getGoalIndex("MBSTART"))
    #move before the red pyramid
    connectParseResultToGoal(stateUnits,goalUnits,30,maes1.getGoalIndex("MBSTART"))

    connectParseBumpToFact()

def oneParseMovesOneControl(parseCells,controlCells,parseCA,newControlCA):
    connectors = []
    #wt = 0.03 #4 chip
    wt = 0.3
    for fromNeuron in range (0,5):
        inpNeuron = parseCA*5 + fromNeuron
        for toNeuron in range (0,5):
            outNeuron = newControlCA*5 + toNeuron
            connectors = connectors + [(inpNeuron,outNeuron,wt,DELAY)]
    excConnector = FromListConnector(connectors)
    nealProjection(parseCells, controlCells, excConnector,'excitatory')


def oneControlStopsOneParse(parseCells,controlCells,parseCA,controlCA):
    connectors = []
    wt = -25.0
    for fromNeuron in range (0,5):
        inpNeuron = controlCA*5 + fromNeuron
        for toNeuron in range (0,5):
            outNeuron = parseCA*5 + toNeuron
            connectors = connectors + [(inpNeuron,outNeuron,wt,DELAY)]
    inhConnector = FromListConnector(connectors)
    nealProjection(controlCells, parseCells, inhConnector,'inhibitory')

def oneControlStartsOneParse(parseCells,controlCells,parseCA,controlCA):
    connectors = []
    wt = 2.0
    for fromNeuron in range (0,5):
        inpNeuron = controlCA*5 + fromNeuron
        for toNeuron in range (0,5):
            outNeuron = parseCA*5 + toNeuron
            connectors = connectors + [(inpNeuron,outNeuron,wt,DELAY)]
    inhConnector = FromListConnector(connectors)
    nealProjection(controlCells, parseCells, inhConnector,'excitatory')

def connectParseAndControl():
    #consider does it need to start first parse state to parse again?
    parseUnits = parse.getStates()
    controlUnits = control.getStates()
    for parseState in (3,5,9,11,14,16,18,20,25,28,30,32,41,49,51,59): #final parse states
        oneParseMovesOneControl(parseUnits,controlUnits,parseState,1)
        oneControlStopsOneParse(parseUnits,controlUnits,parseState,1)
    oneControlStartsOneParse(parseUnits,controlUnits,0,2)

def connectParseGoalToExploreRoom(parseStateCells,cmExploreRoomCells):
    #the goal primes the exploringFSA and the firstRoom
    synWeight = 0.5
    connector = []
    exploreParseState=59*5
    for fromOff in range (0,5):
        for toOff in range (0,5):
            fromNeuron = fromOff + exploreParseState
            toNeuron = toOff
            connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]

            toNeuron = toOff+25
            connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]

    excConnector = FromListConnector(connector)
    nealProjection(parseStateCells,cmExploreRoomCells,excConnector,'excitatory')

def connectParseGoalToFSA(moveBeforeState,parseStateCells,cmFSACells):
    synWeight = 5.0
    connector = []
    mBParseState=moveBeforeState*5
    for fromOff in range (0,5):
        for toOff in range (0,5):
            fromNeuron = fromOff + mBParseState
            toNeuron = toOff 
            connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]

    excConnector = FromListConnector(connector)
    nealProjection(parseStateCells,cmFSACells,excConnector,'excitatory')

def connectParseNamedShape(moveBeforeState,shapeNumber,parseStateCells,
                          cmShapeCells):
    synWeight = 5.0
    connector = []
    for fromOff in range (0,5):
        for toOff in range (0,5):
            fromNeuron = fromOff + moveBeforeState*5
            toNeuron = toOff + shapeNumber*5
            connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]

    excConnector = FromListConnector(connector)
    nealProjection(parseStateCells,cmShapeCells,excConnector,'excitatory')

def connectParseToCogMap():
    parseStateUnits = parse.getStates()
    cmExploreRoomCells = map.getExploreRoomCells()
    connectParseGoalToExploreRoom(parseStateUnits,cmExploreRoomCells)

    cmFSACells = map.getFSACells()
    #move before blue pyramid
    connectParseGoalToFSA(32,parseStateUnits,cmFSACells)
    #move before red stal
    connectParseGoalToFSA(25,parseStateUnits,cmFSACells)
    #move before blue stal
    connectParseGoalToFSA(28,parseStateUnits,cmFSACells)
    #move before red pyramid
    connectParseGoalToFSA(30,parseStateUnits,cmFSACells)
    cmNamedShapeCells = map.getNamedShapeCells()
    connectParseNamedShape(32,0,parseStateUnits,cmNamedShapeCells)
    connectParseNamedShape(25,1,parseStateUnits,cmNamedShapeCells)
    connectParseNamedShape(28,2,parseStateUnits,cmNamedShapeCells)
    connectParseNamedShape(30,3,parseStateUnits,cmNamedShapeCells)


def visionFactStartsCogMapFact(visFact,cmFact,visionCells,cmCells):
        synWeight = 8.0
        connector = []
        for fromOff in range (0,5):
            for toOff in range (0,5):
                fromNeuron = fromOff + visFact*5
                toNeuron = toOff + cmFact*5
                connector=connector+[(fromNeuron,toNeuron,synWeight, DELAY)]
        excConnector = FromListConnector(connector)
        nealProjection(visionCells,cmCells,excConnector,'excitatory') 

        #undoneself.connectViewedFactsToVisionFacts() #move to cabot3

def viewedFactPreventVisionFact(viewedFact,visionFact):
    visionFactCells = vision.getVisionFactCells()
    cmViewedFactCells = map.getViewedFactCells()
    synWeight = -10.0
    connector = []
    for fact in range (0,4):
        for fromOff in range (0,5):
            for toOff in range (0,5):
                fromNeuron = viewedFact*5+fromOff
                toNeuron = visionFact*5+toOff
                connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
    inhConnector = FromListConnector(connector)
    nealProjection(cmViewedFactCells,visionFactCells, inhConnector,'inhibitory')

def cmViewedFactsPreventVisionFacts():
    #blue pyramid
    viewedFactPreventVisionFact(0,0)
    viewedFactPreventVisionFact(0,1)
    viewedFactPreventVisionFact(0,4)

    #redStal
    viewedFactPreventVisionFact(1,2)
    viewedFactPreventVisionFact(1,3)
    viewedFactPreventVisionFact(1,5)

    #blueStal
    viewedFactPreventVisionFact(2,15)
    viewedFactPreventVisionFact(2,16)
    viewedFactPreventVisionFact(2,17)

    #redPyr
    viewedFactPreventVisionFact(3,12)
    viewedFactPreventVisionFact(3,13)
    viewedFactPreventVisionFact(3,14)


def visionFactStartCMInBefore(visFact,beforeFact):
    visionFactCells = vision.getVisionFactCells()
    cmInBeforeCells = map.getInBeforeRoomCells()

    #synWeight = 200.0
    synWeight = 20.0
    #synWeight = 8.0
    #synWeight = 1.0
    connector = []
    for fromOff in range (0,5):
            for toOff in range (0,5):
                fromNeuron = fromOff + visFact*5
                toNeuron = toOff + beforeFact*5
                connector=connector+[(fromNeuron,toNeuron,synWeight, DELAY)]
    
    excConnector = FromListConnector(connector)
    nealProjection(visionFactCells,cmInBeforeCells,excConnector,'excitatory') 

def visionFactsStartCMInBefore():
    #blue pyramid
    #visionFactStartCMInBefore(1,0)
    #visionFactStartCMInBefore(2,0)
    #visionFactStartCMInBefore(5,0)

    #red stal
    #visionFactStartCMInBefore(3,1)
    #visionFactStartCMInBefore(4,1)
    #visionFactStartCMInBefore(5,1)

    #blue pyramid
    visionFactStartCMInBefore(0,0)
    visionFactStartCMInBefore(1,0)
    visionFactStartCMInBefore(4,0)

    #red stal
    visionFactStartCMInBefore(2,1)
    visionFactStartCMInBefore(3,1)
    visionFactStartCMInBefore(5,1)

    #blue stal
    visionFactStartCMInBefore(15,2)
    visionFactStartCMInBefore(16,2)
    visionFactStartCMInBefore(17,2)

    #red pyramid
    visionFactStartCMInBefore(12,3)
    visionFactStartCMInBefore(13,3)
    visionFactStartCMInBefore(14,3)
    
def connectVisionAndCogMap():
    cmViewedFactsPreventVisionFacts()
    visionFactsStartCMInBefore()

    visionFactCells = vision.getVisionFactCells()
    cmShapeFactCells = map.getShapeFactCells()

    #blue pyramid to shape0
    visionFactStartsCogMapFact(0,0,visionFactCells,cmShapeFactCells)
    visionFactStartsCogMapFact(1,0,visionFactCells,cmShapeFactCells)
    visionFactStartsCogMapFact(4,0,visionFactCells,cmShapeFactCells)

    #red stal to shape1
    visionFactStartsCogMapFact(2,1,visionFactCells,cmShapeFactCells)
    visionFactStartsCogMapFact(3,1,visionFactCells,cmShapeFactCells)
    visionFactStartsCogMapFact(5,1,visionFactCells,cmShapeFactCells)

    #blue stal to shape2
    visionFactStartsCogMapFact(15,2,visionFactCells,cmShapeFactCells)
    visionFactStartsCogMapFact(16,2,visionFactCells,cmShapeFactCells)
    visionFactStartsCogMapFact(17,2,visionFactCells,cmShapeFactCells)

    #red pyramid to shape3
    visionFactStartsCogMapFact(12,3,visionFactCells,cmShapeFactCells)
    visionFactStartsCogMapFact(13,3,visionFactCells,cmShapeFactCells)
    visionFactStartsCogMapFact(14,3,visionFactCells,cmShapeFactCells)

def  inBeforePlanStop():
    cmInBeforeCells = map.getInBeforeRoomCells()
    maesFactCells = maes1.getFactPop()

    connector = []
    stopIndex=maes1.getFactIndex("STOPMB")
    synWeight = 0.5
    for fact in range (0,4): 
        for fromOff in range (0,5): 
            for toOff in range (0,5):
                fromNeuron = fromOff+(fact*5)
                toNeuron = stopIndex*5+toOff
                connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
    excConnector = FromListConnector(connector)
    nealProjection(cmInBeforeCells,maesFactCells,excConnector,'excitatory')


def goalGOPreventsCMShapeFacts(maesGoalCells):
    cmShapeFactCells = map.getShapeFactCells()
    indexGO = maes1.getGoalIndex("GO")
    synWeight = -10.0
    connector = []

    for fromNeuron in range (indexGO*5,(indexGO*5)+5):
        for toNeuron in range (0,20):
            connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]

    inhConnector = FromListConnector(connector)
    nealProjection(maesGoalCells,cmShapeFactCells, inhConnector,'inhibitory')


def factStopPreventsCMBefore(maesFactCells):
    cmInBeforeCells = map.getInBeforeRoomCells()
    stopIndex=maes1.getFactIndex("STOP")
    synWeight = -10.0
    connector = []

    for fromNeuron in range (stopIndex*5,(stopIndex*5)+5):
        for toNeuron in range (0,20):
            connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]

    inhConnector = FromListConnector(connector)
    nealProjection(maesFactCells,cmInBeforeCells, inhConnector,'inhibitory')


def beforeShapeStartsMBReadyFact(maesFactCells):
    cmBeforeShapeCells = map.getBeforeShapeCells()
    mBReadyIndex=maes1.getFactIndex("MBREADY")
    synWeight = 1.0
    connector = []

    for fromNeuron in range (0,20):
        for toNeuron in range (mBReadyIndex*5,(mBReadyIndex*5)+5):
            connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]

    excConnector = FromListConnector(connector)
    nealProjection(cmBeforeShapeCells,maesFactCells, excConnector,'excitatory')

def connectCogMapToPlan():
    inBeforePlanStop()
    cmExploreRoomCells = map.getExploreRoomCells()
    goalUnits = maes1.getGoalCells()
    maesFactCells = maes1.getFactPop()

    goalGOPreventsCMShapeFacts(goalUnits)
    factStopPreventsCMBefore(maesFactCells)    
    beforeShapeStartsMBReadyFact(maesFactCells)

    #The exploring state and lastNext turns on stop
    synWeight = 0.025
    stopIndex=maes1.getFactIndex("STOP")
    connector = []
    for fromOff in range (25,30):
        for toOff in range (0,5):
            fromNeuron = fromOff
            toNeuron = stopIndex*5+toOff
            connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
    synWeight = 0.1
    #the off FSA turns on stop
    for fromOff in range (30,35): 
        for toOff in range (0,5):
            fromNeuron = fromOff
            toNeuron = stopIndex*5+toOff
            connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
    excConnector = FromListConnector(connector)
    nealProjection(cmExploreRoomCells,maesFactCells,excConnector,'excitatory')


def test():
    input = vision.getBWVisionInputCells()
    weight = 20.0
    connectors = []
    for i  in range(0,neuronsPerSubnet):
        #connectors = connectors + [(i,0,weight,DELAY)]
        connectors = connectors + [(i,i,weight,DELAY)]
    connectorList = FromListConnector(connectors) 
    nealProjection(input,testCells, connectorList,'excitatory')

    return

def testColour():
    input = vision.getColourVisionInputCells()
    weight = 20.0
    connectors = []
    for i  in range(0,1200):
        #connectors = connectors + [(i,0,weight,DELAY)]
        connectors = connectors + [(i,i,weight,DELAY)]
    connectorList = FromListConnector(connectors) 
    nealProjection(input,testCells, connectorList,'excitatory')

    return

def recordCABot3():
    vision.setVisionRecording()
    maes1.setPlanRecording()
    parse.setRecording()
    #control.setControlRecording()
    map.setCogMapRecording()


def printCABot3():
    vision.printVisionNets()
    maes1.printMaes() 
    #parse.printResults()
    #control.printControlNets()
    map.printCogMapResults()


def addTestConnection(toCells):
    goalUnits = maes1.getGoalCells()
    rtGoal = maes1.getGoalIndex("TR")

    weight = 5.0
    connector = []
    for inpOffset in range (0,5):
        inpNeuron = inpOffset + rtGoal*5
        for toNeuron in range (0,20):
            connector = connector + [(inpNeuron,toNeuron,weight,DELAY)]
    
    print "hey",connector
    connList = FromListConnector(connector)
    nealProjection(goalUnits,toCells,connList, 'excitatory')



#------------Main Body---------------
#import the simulator via nealParams.py
#simulator_name = get_script_args(1)[0]  
#exec("from pyNN.%s import *" % simulator_name)

setup(timestep=DELAY,min_delay=DELAY,max_delay=DELAY,debug=0)

#----------------create neurons

parse = parseArea(simulator_name)
#--------------external input parse needs to be before connections 
#parse.setSpikeServerInputs()
parse.allocateParseNeurons()

vision = visionArea(simulator_name)
vision.setWhatsOn(4) #4,3,2,1=off
vision.allocateVisionNeurons()

maes1 = Maes()

control = controlArea()
control.allocateControlNeurons()

map = cogmap(simulator_name)
map.allocateCogMapNeurons()

 
#---------setup connections
vision.makeVisionSynapses()
maes1.networkFromCSV("maesNetwork.dat")
parse.setConnections()

spikes = [[0]]
controlInputSource=Population(1,SpikeSourceArray,{'spike_times':spikes})
control.makeControlSynapses(controlInputSource)
map.startExploreFSA(controlInputSource)

map.setCogMapConnections()

#connect subsytems
connectVisionToPlan()
connectParseToPlan()
connectParseAndControl()
connectParseToCogMap()
connectVisionAndCogMap()
connectCogMapToPlan()


cell_params = {'tau_refrac' : 3.0, 'v_rest' : -65.0, 'v_thresh' : -51.0,  'tau_syn_E'  : 2.0, 'tau_syn_I': 5.0,    'v_reset'    : -70.0,  'i_offset' : 0.1}
#testCells=Population(neuronsPerSubnet, IF_curr_exp, cell_params)
#testCells=Population(1200, IF_curr_exp, cell_params)
#testCells.record()
#test()
#testColour()

#-------------------setup recording
recordCABot3()

runNoCallBack()

#--------------print results
print "done running"

printCABot3()

#testCells.printSpikes('results/test.sp')

end()

