"""
This is four room with corridors and shapes in the middle.  There are some
problems with back shapes and corridors being written, but that's probably ok.
Writes sentences and pictures to spinnaker.
Reads actions from the callbackFromBoard 
"""

fUseSpikeServer = True

if (fUseSpikeServer):
    from Tkinter import Tk, Canvas, BOTH
    from Tkinter import *
    from ttk import Frame, Button, Style
    import Image
    from toSpikeServe import spikeQueue
    from getPixelsClass import imageToPixelClass
    import sys
    from spinnman.connections.udp_packet_connections.stripped_iptag_connection \
        import StrippedIPTagConnection
    from spinnman import constants
    from spynnaker.pyNN.utilities.conf import config
    sys.path.append('../')
    from nealParams import *
else:
    from Tkinter import Tk, Canvas, BOTH
    from Tkinter import *
    #import Image
    from getPixelsClass import imageToPixelClass

import numpy as np
import math
import time

myGreen = "#00ff00"
myRed = "#ff0000"
myBlue = "#0000ff"

class Environment(Frame):
    newPicture = True

    wordsForward=[0,11,8,12] # start parse,move,forward,period.
    wordsBack=[0,11,2,12] # start parse,move,back,period.
    wordsLeft=[0,21,10,12]  # start parse,turn,left,period.
    wordsRight=[0,21,14,12] # start parse,turn,right,period.
    wordsMoveLeft=[0,11,10,12] # start parse,move,lef,period.
    wordsMoveRight=[0,11,14,12] # start parse,move,right,period.
    wordsTurnPyramid=[0,21,20,18,13,12]  #start parse,turn,toward,the,pyr,per.
    wordsTurnStalactite=[0,21,20,18,15,12]  #sp,turn,toward,the,stal,per.
    wordsGoToTheBarredPyramid=[0,9,19,18,3,13,12]  #sp,go,to,the,barred,pyr,per.
    wordsGoToTheBarredStalactite=[0,9,19,18,3,15,12] #sp,go,to,the,bar,stal,per.
    wordsGoToTheDoor=[0,9,19,18,6,12] #sp,go,to,the,door,per.
    wordsExplore=[0,7,12] #sp,explore,per.
    wordsMoveBeforeTheBluePyramid=[0,11,4,18,3,13,12]  #sp,Move,to,the,barred,pyr,per.
    wordsMoveBeforeTheRedPyramid=[0,11,4,18,17,13,12]  #sp,Move,to,the,striped,pyr,per.
    wordsMoveBeforeTheRedStalactite=[0,11,4,18,17,15,12]  #sp,Move,to,the,striped,stal,per.
    wordsMoveBeforeTheBlueStalactite=[0,11,4,18,3,15,12]  #sp,Move,to,the,barred,stal,per.

    numFiles = 0
    numUserFiles = 0

    gotCommandFromSpinnaker = False

    rm1Object = "pyr1"
    rm2Object = "stal1"
    rm3Object = "stal2"
    rm4Object = "pyr2"

    agentLocale = 1 #1,2,3,4 for room, 5,6,7,8 for corridors

    #In corr enter room 1 from room 4
    #agentLocale = 8
    #direction = 1.57
    #camera = np.array([1159.0,300.0,500.0,1.0])

    #enter room 1 from room 4
    direction = 1.57
    camera = np.array([999.0,300.0,500.0,1.0])

    #entering room2 from room1
    #agentLocale = 2
    #direction = 0.0
    #camera = np.array([500.0,300.0,2001.0,1.0]) 
    #direction = 6.09
    #camera = np.array([528.0,300.0,2148.0,1.0]) 

    #entering room3 from room2
    #agentLocale = 3
    #direction = 4.7
    #camera = np.array([2001.0,300.0,2500.0,1.0]) 

    #entering room4 from room3
    #agentLocale = 4
    #direction = 3.1
    #camera = np.array([2500.0,300.0,999.0,1.0]) 
    
    #leaving room 1 toward room 2
    #direction = 6.25
    #camera = np.array([500.0,300.0,800.0,1.0]) 

    #room1 past pyramid door on left
    #direction = 0.03
    #camera = np.array([706.0,300.0,687.0,1.0]) 

    #corridor 1 leaving room 1 toward room 2
    #direction = 6.25
    #camera = np.array([500.0,300.0,1500.0,1.0]) 

    #enter room 1 from room 4 3 steps
    #direction = 1.57
    #camera = np.array([849.0,300.0,500.0,1.0])

    #enter room 1 from room 4 5 steps
    #direction = 1.57
    #camera = np.array([749.0,300.0,500.0,1.0])

    #blue pyramid on right
    #direction = 1.57
    #camera = np.array([849.0,300.0,350.0,1.0])
    #direction = 2.10 
    #camera = np.array([899.0,300.0,500.0,1.0]) 

    #blue pyramid on left
    #direction = 1.10 
    #camera = np.array([899.0,300.0,500.0,1.0]) 
    #direction = 1.57
    #camera = np.array([849.0,300.0,650.0,1.0])

    #against wall room 1 pyramid then cor to room2
    #direction = 0.0
    #camera = np.array([500.0,300.0,1.0,1.0]) 

    #against wall room 3
    #direction = 0.0
    #camera = np.array([2500.0,300.0,2001.0,1.0]) 
    
    #against wall room 4
    #direction = 0.0
    #camera = np.array([2500.0,300.0,1.0,1.0]) 

    #corr 2 facing room3
    #direction = 4.7
    #camera = np.array([1001.0,300.0,2500.0,1.0]) 
    
    #corr 3 facing room4
    #direction = 3.1
    #camera = np.array([2500.0,300.0,1999.0,1.0]) 
    
    #corr 4 facing room1
    #direction = 1.6
    #camera = np.array([2001.0,300.0,500.0,1.0]) 
    
    #corr1 facing room 1
    #direction = 3.1
    #camera = np.array([500.0,300.0,1101.0,1.0]) 

    #corridor facing room 1 slightly turned right
    #direction = 2.91
    #camera = np.array([505.0,300.0,1241.0,1.0]) 

    #against wall room 1, pyramid, cor on right 
    #direction = 1.57
    #camera = np.array([999.0,300.0,500.0,1.0]) #distant centre

    #room 1 facing cor, pyramid behind
    #direction = 0.0
    #camera = np.array([500.0,300.0,951.0,1.0]) 

    pyrP1 = np.array([400,400,400,1.0]) 
    pyrP2 = np.array([600.0,400.0,400.0,1.0]) 
    pyrP3 = np.array([600.0,400.0,600.0,1.0])
    pyrP4 = np.array([400.0,400.0,600.0,1.0])
    pyrP5 = np.array([500.0,200.0,500.0,1.0])

    pyr1BumpP1 = np.array([300,400,300,1.0]) 
    #pyr1BumpP3 = np.array([700.0,400.0,600.0,1.0])
    pyr1BumpP3 = np.array([750.0,400.0,600.0,1.0])

    pyr2P1 = np.array([2400,400,400,1.0]) 
    pyr2P2 = np.array([2600.0,400.0,400.0,1.0]) 
    pyr2P3 = np.array([2600.0,400.0,600.0,1.0])
    pyr2P4 = np.array([2400.0,400.0,600.0,1.0])
    pyr2P5 = np.array([2500.0,200.0,500.0,1.0])

    pyr2BumpP1 = np.array([2400,400,300,1.0]) 
    #pyr2BumpP3 = np.array([2700.0,400.0,700.0,1.0])
    pyr2BumpP3 = np.array([2700.0,400.0,750.0,1.0])

    stalP1 = np.array([400,200,2400,1.0]) 
    stalP2 = np.array([600.0,200.0,2400.0,1.0]) 
    stalP3 = np.array([600.0,200.0,2600.0,1.0])
    stalP4 = np.array([400.0,200.0,2600.0,1.0])
    stalP5 = np.array([500.0,400.0,2500.0,1.0])

    #stal1BumpP1 = np.array([300,400,2300,1.0]) 
    stal1BumpP1 = np.array([300,400,2250,1.0]) 
    stal1BumpP3 = np.array([600.0,400.0,2700.0,1.0])

    stal2P1 = np.array([2400,200,2400,1.0]) 
    stal2P2 = np.array([2600.0,200.0,2400.0,1.0]) 
    stal2P3 = np.array([2600.0,200.0,2600.0,1.0])
    stal2P4 = np.array([2400.0,200.0,2600.0,1.0])
    stal2P5 = np.array([2500.0,400.0,2500.0,1.0])

    #stal2BumpP1 = np.array([2300,200,2400,1.0]) 
    stal2BumpP1 = np.array([2250,200,2400,1.0]) 
    stal2BumpP3 = np.array([2700.0,200.0,2700.0,1.0])

    rm1P1 = np.array([0.0,      0.0,   0.0,1.0])
    rm1P2 = np.array([0.0,      1000.0,0.0,1.0])
    rm1P3 = np.array([0.0,      0.0,   1000.0,1.0])
    rm1P3a = np.array([400.0,   0.0,   1000.0,1.0])
    rm1P3b = np.array([600.0,   0.0,   1000.0,1.0])
    rm1P4 = np.array([0.0,      1000.0,1000.0,1.0])
    rm1P4a = np.array([400.0,   1000.0,1000.0,1.0])
    rm1P4b = np.array([600.0,   1000.0,1000.0,1.0])
    rm1P5 = np.array([1000.0,   0.0,   1000.0,1.0])
    rm1P5a = np.array([1000.0,  0.0,   600.0,1.0])
    rm1P5b = np.array([1000.0,  0.0,   400.0,1.0])
    rm1P6 = np.array([1000.0,   1000.0,1000.0,1.0])
    rm1P6a = np.array([1000.0,  1000.0,600.0,1.0])
    rm1P6b = np.array([1000.0,  1000.0,400.0,1.0])
    rm1P7 = np.array([1000.0,   0.0,   0.0,1.0])
    rm1P8 = np.array([1000.0,   1000.0,0.0,1.0])

    rm2P1 = np.array([0.0,      0.0,   2000.0,1.0])
    rm2P2 = np.array([0.0,      1000.0,2000.0,1.0])
    rm2P3 = np.array([0.0,      0.0,   3000.0,1.0])
    rm2P4 = np.array([0.0,      1000.0,3000.0,1.0])
    rm2P5 = np.array([1000.0,   0.0,   3000.0,1.0])
    rm2P5a = np.array([1000.0,  0.0,   2600.0,1.0])
    rm2P5b = np.array([1000.0,  0.0,   2400.0,1.0])
    rm2P6 = np.array([1000.0,   1000.0,3000.0,1.0])
    rm2P6a = np.array([1000.0,  1000.0,2600.0,1.0])
    rm2P6b = np.array([1000.0,  1000.0,2400.0,1.0])
    rm2P7 = np.array([1000.0,   0.0,   2000.0,1.0])
    rm2P7a = np.array([600.0,   0.0,   2000.0,1.0])
    rm2P7b = np.array([400.0,   0.0,   2000.0,1.0])
    rm2P8 = np.array([1000.0,   1000.0,2000.0,1.0])
    rm2P8a = np.array([600.0,   1000.0,2000.0,1.0])
    rm2P8b = np.array([400.0,   1000.0,2000.0,1.0])

    rm3P1 = np.array([2000.0,      0.0,   2000.0,1.0])
    rm3P1a = np.array([2000.0,     0.0,   2400.0,1.0])
    rm3P1b = np.array([2000.0,     0.0,   2600.0,1.0])
    rm3P2 = np.array([2000.0,      1000.0,2000.0,1.0])
    rm3P2a = np.array([2000.0,     1000.0,2400.0,1.0])
    rm3P2b = np.array([2000.0,     1000.0,2600.0,1.0])
    rm3P3 = np.array([2000.0,      0.0,   3000.0,1.0])
    rm3P4 = np.array([2000.0,      1000.0,3000.0,1.0])
    rm3P5 = np.array([3000.0,      0.0,   3000.0,1.0])
    rm3P6 = np.array([3000.0,      1000.0,3000.0,1.0])
    rm3P7 = np.array([3000.0,      0.0,   2000.0,1.0])
    rm3P7a = np.array([2600.0,     0.0,   2000.0,1.0])
    rm3P7b = np.array([2400.0,     0.0,   2000.0,1.0])
    rm3P8 = np.array([3000.0,      1000.0,2000.0,1.0])
    rm3P8a = np.array([2600.0,     1000.0,2000.0,1.0])
    rm3P8b = np.array([2400.0,     1000.0,2000.0,1.0])

    rm4P1 = np.array([2000.0,      0.0,   0.0,1.0])
    rm4P1a = np.array([2000.0,     0.0,   400.0,1.0])
    rm4P1b = np.array([2000.0,     0.0,   600.0,1.0])
    rm4P2 = np.array([2000.0,      1000.0,0.0,1.0])
    rm4P2a = np.array([2000.0,     1000.0,400.0,1.0])
    rm4P2b = np.array([2000.0,     1000.0,600.0,1.0])
    rm4P3 = np.array([2000.0,      0.0,   1000.0,1.0])
    rm4P3a = np.array([2400.0,     0.0,   1000.0,1.0])
    rm4P3b = np.array([2600.0,     0.0,   1000.0,1.0])
    rm4P4 = np.array([2000.0,      1000.0,1000.0,1.0])
    rm4P4a = np.array([2400.0,     1000.0,1000.0,1.0])
    rm4P4b = np.array([2600.0,     1000.0,1000.0,1.0])
    rm4P5 = np.array([3000.0,      0.0,   1000.0,1.0])
    rm4P6 = np.array([3000.0,      1000.0,1000.0,1.0])
    rm4P7 = np.array([3000.0,      0.0,   0.0,1.0])
    rm4P8 = np.array([3000.0,      1000.0,0.0,1.0])



    translationMatrix = np.array([[1.0,0.0,0.0,0.0],
                                  [0.0,1.0,0.0,0.0],
                                  [0.0,0.0,1.0,0.0],
                                  [0.0,0.0,0.0,1.0]])


    def __init__(self, parent):
        self.fileNum = 0
        Frame.__init__(self, parent)   
         
        #setup the call back for spikes from action
        if (fUseSpikeServer):
            packet_grabber = \
                         StrippedIPTagConnection(local_port=config.get(
                             "Recording","live_spike_port"))
            packet_grabber.register_callback(self.callbackFromBoard,
                                 constants.TRAFFIC_TYPE.EIEIO_DATA)


        self.parent = parent        
        self.initUI()

    def callbackFromBoard(self,packet):
        #print "fromBoard ", packet
        action = packet.data[0]
        if (action == 0):
            self.turnRight()
        elif (action == 1):
            self.turnLeft()
        elif (action == 2):
            self.moveForward()
        elif (action == 3):
            self.moveBack()
        else:
            print "bad action in environment.py ",action
            return
        self.newPicture = True

    def forward(self):
        self.toSpinQ.writeSentence(self.wordsForward,4)

    def back(self):
        self.toSpinQ.writeSentence(self.wordsBack,4)

    def left (self):
        self.toSpinQ.writeSentence(self.wordsLeft,4)

    def right (self):
        self.toSpinQ.writeSentence(self.wordsRight,4)

    def processTextInput (self, textInput):
        #clear whitespace before and after
        input = textInput.rstrip()
        input = input.lstrip()

        #test for characters.
        if input.__len__() == 1:
            if input == "r":
                self.toSpinQ.writeSentence(self.wordsRight,4)
            elif input == "l":
                self.toSpinQ.writeSentence(self.wordsLeft,4)
            elif input == "f":
                self.toSpinQ.writeSentence(self.wordsForward,4)
            elif input == "b":
                self.toSpinQ.writeSentence(self.wordsBack,4)
            elif input == "x":
                self.toSpinQ.writeSentence(self.wordsExplore,3)
            elif input == "R":
                self.toSpinQ.writeSentence(self.wordsMoveRight,4)
            elif input == "L":
                self.toSpinQ.writeSentence(self.wordsMoveLeft,4)
            elif input == "p":
                self.toSpinQ.writeSentence(self.wordsTurnPyramid,6)
            elif input == "s":
                self.toSpinQ.writeSentence(self.wordsTurnStalactite,6)
            elif input == "P":
                self.toSpinQ.writeSentence(self.wordsGoToTheBarredPyramid,7)
            elif input == "S":
                self.toSpinQ.writeSentence(self.wordsGoToTheBarredStalactite,7)
            elif input == "D":
                self.toSpinQ.writeSentence(self.wordsGoToTheDoor,6)
            elif input == "a":
                self.toSpinQ.writeSentence(self.wordsMoveBeforeTheBluePyramid,7)
            elif input == "e":
                self.toSpinQ.writeSentence(self.wordsMoveBeforeTheRedStalactite,7)
            elif input == "c":
                self.toSpinQ.writeSentence(self.wordsMoveBeforeTheBlueStalactite,7)
            elif input == "d":
                self.toSpinQ.writeSentence(self.wordsMoveBeforeTheRedPyramid,7)
            else:
               print ("bad text input ", textInput)
        #test for complete sentences
        else:   
            input = input.lower()
            if input == "turn right.":
                self.toSpinQ.writeSentence(self.wordsRight,3)
            elif input == "turn left.":
                self.toSpinQ.writeSentence(self.wordsLeft,3)
            elif input == "move forward.":
                self.toSpinQ.writeSentence(self.wordsForward,3)
            elif input == "move back.":
                self.toSpinQ.writeSentence(self.wordsBack,3)
            elif input == "move right.":
                self.toSpinQ.writeSentence(self.wordsMoveRight,3)
            elif input == "move left.":
                self.toSpinQ.writeSentence(self.wordsMoveLeft,3)
            elif input == "turn toward the pyramid":
                self.toSpinQ.writeSentence(self.wordsTurnPyramid,6)
            elif input == "turn toward the stalactite":
                self.toSpinQ.writeSentence(self.wordsTurnStalactite,6)
            elif input == "go to the barred pyramid.":
                self.toSpinQ.writeSentence(self.wordsGoToTheBarredPyramid,7)
            elif input == "go to the barred stalactite.":
                self.toSpinQ.writeSentence(self.wordsGoToTheBarredStalactite,7)
            elif input == "go to the door.":
                self.toSpinQ.writeSentence(self.wordsGoToTheDoor,6)
            elif input == "explore.":
                self.toSpinQ.writeSentence(self.wordsExplore,3)
            elif input == "move before the blue pyramid.":
                self.toSpinQ.writeSentence(self.wordsMoveBeforeTheBluePyramid,7)
            elif input == "move before the red pyramid.":
                self.toSpinQ.writeSentence(self.wordsMoveBeforeTheRedPyramid,7)
            elif input == "move before the red stalactite.":
                self.toSpinQ.writeSentence(self.wordsMoveBeforeTheRedStalacite,7)
            elif input == "move before the blue stalactite.":
                self.toSpinQ.writeSentence(self.wordsMoveBeforeTheBlueStalacite,7)
            else:
                print "bad text input ", textInput


    def dumpBinCount(self):
        fileName = "..data/userTest" + str(self.numUserFiles) + ".txt"
        file = open(fileName,"w")
        file.write(time.asctime())
        file.write("\n")
        file.close()
        self.numUserFiles = 1
        self.toSpinQ.addConditionalTicks(1000)

    def testPixels(self):
        print "Test Pixels"
        self.canvas.postscript(file="file_name.ps", colormode='color')
        image = Image.open("file_name.ps")
        image.save("temp.jpg","JPEG")
        toSpinPic = self.imageTranslator.getPixelsFromFile("temp.jpg")
        print toSpinPic
        return

    def dumpJPG(self):
        self.canvas.postscript(file="file_name.ps", colormode='color')
        image = Image.open("file_name.ps")
        image.save("temp.jpg","JPEG")
        #self.canvas.save(file="temp.jpg")
            
        #print "dumpJPG"

    def putTextInFile(self,text):
        file = open("test.txt","w")
        file.write(text)
        
        print (text)

    ##-- get actions from spinnaker stored in text files
    def readFromSpin(self):
        return
        fileInName = "../data/fromCABot2" + str(self.numFiles) + ".txt"
        
        try:
            self.fileIn = open (fileInName,"rt")
        except IOError, e:
            #print "file not yet created", e  #keep looking for a new file
            if self.gotCommandFromSpinnaker:
                #print "act" , self.toSpinQ.ticksSent
                self.toSpinQ.addConditionalTicks(33)  #100/3 
            if SIM_LENGTH > self.toSpinQ.ticksSent:
                self.after(100,self.readFromSpin)
            return

        commandNum = self.fileIn.read()
        self.gotCommandFromSpinnaker = True
        if (commandNum == "0"):
            self.turnRight()
        elif (commandNum == "1"):
            self.turnLeft()
        elif (commandNum == "2"):
            self.moveForward()
        elif (commandNum == "3"):
            self.moveBack()
        else:
            print ("bad action ", temp)
            
        self.fileIn.close()
        self.numFiles = self.numFiles + 1
        self.after(100,self.readFromSpin)

    fPrintedCommand = False
    fPrintedNoCommand = False

    def writePictureToSpin(self):
        #undone there must be a better way than making two files
        if (self.newPicture) or (self.stepsSinceLastUpdate >= 100):
            self.reDraw()
            self.canvas.postscript(file="file_name.ps", colormode='color')
            image = Image.open("file_name.ps")
            jpgName = "data/temp"+str(self.fileNum)+".jpg"
            #image.save("temp.jpg","JPEG")
            image.save(jpgName,"JPEG")
            self.fileNum = self.fileNum + 1
            #toSpinPic = self.imageTranslator.getPixelsFromFile("temp.jpg")
            toSpinPic = self.imageTranslator.getPixelsFromFile(jpgName)
            self.toSpinBWPic = toSpinPic[0]
            self.toSpinColourPic = toSpinPic[1]
            self.newPicture = False
            self.stepsSinceLastUpdate =  0
        else:
            self.stepsSinceLastUpdate =  self.stepsSinceLastUpdate + 1

        #print toSpinBWPic
        self.toSpinQ.writeBWPicture(self.toSpinBWPic,self.toSpinBWPic.__len__())
        self.toSpinQ.writeColourPicture(self.toSpinColourPic,
                                       self.toSpinColourPic.__len__())
        self.toSpinQ.sendWord()

        if self.gotCommandFromSpinnaker:
            if (not self.fPrintedCommand):
                print ("got command in wpts")
                self.fPrintedCommand = True
        else:
            if (not self.fPrintedNoCommand):
                print ("dont got command in wpts")
                self.fPrintedNoCommand = True

        #self.after(20,self.writePictureToSpin)
        self.after(6,self.writePictureToSpin)

    #-----Functions for drawing the environment
    def deleteWalls(self,walls):
        for wall in walls:
            self.canvas.delete(wall)

    def reDraw(self):
        self.deleteWalls(self.walls)
        self.walls = self.drawWalls()
        
        #undone I don't do a good job of deleting old shapes.
        self.canvas.delete(self.triangle1)
        self.canvas.delete(self.triangle2)
        self.canvas.delete(self.triangle3)
        self.canvas.delete(self.triangle4)
        self.drawPyramid()
        self.drawPyramid2()
        self.drawStalactite()
        self.drawStalactite2()

        #do this last so it covers all other rooms
        self.drawCurrentRoom()
        

    def clipPoint(self,pointFront,pointBack):
        slope = (pointFront[0]-pointBack[0])/(pointFront[2]-pointBack[2])
        #print "slope", slope, pointFront,pointBack

        #b = y - mx = y-slope*x solve for b
        b = pointFront[0]-(slope*pointFront[2])

        #get x intercept,  y = 0, b = -slope(x), x = b/-slope
        #x = (b/slope)*-1
        #print b,x
        #get y intercept x = 0, y=b

        
        pointBack[2] = 0
        #offset * foveal length (what do we do when b is between -5 and 2.5)
        #pointBack[0] = b*20
        if b < 0:
            pointBack[0] = -500
        else:
            pointBack[0] = 500
    
        return pointBack

    def drawWall(self,point0,point1,point2,point3,fillColour):
        #translate to camera = 0,0,0 coordinates
        p0 = point0-self.camera
        p1 = point1-self.camera
        p2 = point2-self.camera
        p3 = point3-self.camera
        #print "s",p0,p1,p2,p3

        #rotate depending on the way the user is facing
        p0 = np.dot(self.translationMatrix,p0)
        p1 = np.dot(self.translationMatrix,p1)
        p2 = np.dot(self.translationMatrix,p2)
        p3 = np.dot(self.translationMatrix,p3)
        #print "r",p0,p1,p2,p3

        #project onto 2D
        fovealLength = 200 

        if (p0[2] == 0): p0[2] = 0.01
        if (p1[2] == 0): p1[2] = 0.01
        if (p2[2] == 0): p2[2] = 0.01
        if (p3[2] == 0): p3[2] = 0.01

        #clip walls entirely behind the camera
        if (p0[2] < 0) and (p1[2] < 0) and (p2[2] < 0) and (p3[2] < 0):
            return

        distP0 = fovealLength/p0[2]
        distP1 = fovealLength/p1[2]
        distP2 = fovealLength/p2[2]
        distP3 = fovealLength/p3[2]

        tp0 = p0
        tp1 = p1
        tp2 = p2
        if (p0[2] > 0): p0 = p0*distP0
        elif (p0[2] < 0) and (p2[2] > 0):
            p0 = self.clipPoint(p2,p0)
        elif (p0[2] < 0) and (p1[2] > 0):
            p0 = self.clipPoint(p1,p0)
        elif (p0[2] < 0) and (p3[2] > 0):
            p0 = self.clipPoint(p3,p0)
        else: print "unclipped p0",p0,p1,p2,p3

        if (p1[2] > 0): p1 = p1*distP1
        elif (p1[2] < 0) and (p3[2] > 0):
            p1 = self.clipPoint(p3,p1)
        elif (p1[2] < 0) and (tp0[2] > 0):
            p1 = self.clipPoint(tp0,p1)
        elif (p1[2] < 0) and (p2[2] > 0):
            p1 = self.clipPoint(p2,p1)
        else: print "unclipped p1"

        if (p2[2] > 0): p2 = p2*distP2
        elif (p2[2] < 0) and (tp0[2] > 0):
            p2 = self.clipPoint(tp0,p2)
        elif (p2[2] < 0) and (p3[2] > 0):
            p2 = self.clipPoint(p3,p2)
        elif (p2[2] < 0) and (tp1[2] > 0):
            p2 = self.clipPoint(tp1,p2)
        else: print "unclipped p2"

        if (p3[2] > 0): p3 = p3*distP3
        elif (p3[2] < 0) and (tp1[2] > 0):
            p3 = self.clipPoint(tp1,p3)
        elif (p3[2] < 0) and (tp2[2] > 0):
            p3 = self.clipPoint(tp2,p3)
        elif (p3[2] < 0) and (tp0[2] > 0):
            p3 = self.clipPoint(tp0,p3)
        else: print "unclipped p3"

        #print "d",p0,p1,p2,p3

        #move to the centre of the picture
        offset = np.array([250,250,0,0])
        p0=p0 + offset
        p1=p1 + offset
        p2=p2 + offset
        p3=p3 + offset
        #print "o", p0,p1,p2,p3

        points = [p0[0], p0[1], p1[0], p1[1], p3[0], p3[1],p2[0], p2[1]]
        wall = self.canvas.create_polygon(points, outline='gray',
                                          fill=fillColour, width=2)
        return wall

    #draw a room with two corridors.  
    def drawRoom(self,p1,p2,p3,p4,p3a,p3b,p4a,p4b,p5,p6,p5a,p5b,p6a,p6b,p7,p8):
        withColour = False
        if withColour:
            wall2a = self.drawWall(p3,p4,p3a,p4a,'orange')
            wall2b = self.drawWall(p3b,p4b,p5,p6,'red')
            wall3a = self.drawWall(p5,p6,p5a,p6a,'pink')
            wall3b = self.drawWall(p5b,p6b,p7,p8,'green')
            wall4 = self.drawWall(p7,p8,p1,p2,'blue')
            wall1 = self.drawWall(p1,p2,p3,p4,'purple')
            floor = self.drawWall(p4,p2,p6,p8,'orange')
            roof = self.drawWall(p3,p1,p5,p7,'purple')
        else:
            wall2a = self.drawWall(p3,p4,p3a,p4a,'gray')
            wall2b = self.drawWall(p3b,p4b,p5,p6,'gray')
            wall3a = self.drawWall(p5,p6,p5a,p6a,'gray')
            wall3b = self.drawWall(p5b,p6b,p7,p8,'gray')
            wall4 = self.drawWall(p7,p8,p1,p2,'gray')
            wall1 = self.drawWall(p1,p2,p3,p4,'gray')
            floor = self.drawWall(p4,p2,p6,p8,'gray')
            roof = self.drawWall(p3,p1,p5,p7,'gray')

        return [wall1,wall2a,wall2b,wall3a,wall3b,wall4,floor,roof]

    def drawCorridor(self,p1a,p2a,p3a,p4a,p1b,p2b,p3b,p4b):
        withColour = True
        if withColour:
            colour = myGreen
            wall1 = self.drawWall(p1a,p2a,p3a,p4a,colour)
            wall2 = self.drawWall(p3b,p4b,p1b,p2b,'red')
            wall2 = self.drawWall(p3b,p4b,p1b,p2b,colour)
            roof = self.drawWall(p3a,p1a,p3b,p1b,colour)
            floor = self.drawWall(p4a,p2a,p4b,p2b,colour)
        else:
            wall1 = self.drawWall(p1a,p2a,p3a,p4a,'gray')
            wall2 = self.drawWall(p3b,p4b,p1b,p2b,'gray')
            roof = self.drawWall(p3a,p1a,p3b,p1b,'gray')
            floor = self.drawWall(p4a,p2a,p4b,p2b,'gray')

        return [wall1,wall2,roof,floor]

    def drawWalls(self):
        self.setRotation()
        room1Walls = self.drawRoom(self.rm1P1,self.rm1P2,self.rm1P3,self.rm1P4,
                                   self.rm1P3a,self.rm1P3b,self.rm1P4a,
                                   self.rm1P4b,self.rm1P5,self.rm1P6,
                                   self.rm1P5a,self.rm1P5b,self.rm1P6a,
                                   self.rm1P6b,self.rm1P7,self.rm1P8)
        room2Walls = self.drawRoom(self.rm2P3,self.rm2P4,self.rm2P5,self.rm2P6,
                                   self.rm2P5a,self.rm2P5b,self.rm2P6a,
                                   self.rm2P6b,self.rm2P7,self.rm2P8,
                                   self.rm2P7a,self.rm2P7b,self.rm2P8a,
                                   self.rm2P8b,self.rm2P1,self.rm2P2)
        room3Walls = self.drawRoom(self.rm3P5,self.rm3P6,self.rm3P7,self.rm3P8,
                                   self.rm3P7a,self.rm3P7b,self.rm3P8a,
                                   self.rm3P8b,self.rm3P1,self.rm3P2,
                                   self.rm3P1a,self.rm3P1b,self.rm3P2a,
                                   self.rm3P2b,self.rm3P3,self.rm3P4) 
        room4Walls = self.drawRoom(self.rm4P7,self.rm4P8,self.rm4P1,self.rm4P2,
                                   self.rm4P1a,self.rm4P1b,self.rm4P2a,
                                   self.rm4P2b,self.rm4P3,self.rm4P4,
                                   self.rm4P3a,self.rm4P3b,self.rm4P4a,
                                   self.rm4P4b,self.rm4P5,self.rm4P6) 
        cor4Walls = self.drawCorridor(self.rm4P1a,self.rm4P2a,self.rm1P5b,
                              self.rm1P6b,self.rm4P1b,self.rm4P2b,
                              self.rm1P5a,self.rm1P6a)

        cor3Walls = self.drawCorridor(self.rm3P7a,self.rm3P8a,self.rm4P3b,
                              self.rm4P4b,self.rm3P7b,self.rm3P8b,
                              self.rm4P3a,self.rm4P4a)

        cor2Walls = self.drawCorridor(self.rm2P5a,self.rm2P6a,self.rm3P1b,
                              self.rm3P2b,self.rm2P5b,self.rm2P6b,
                              self.rm3P1a,self.rm3P2a)

        cor1Walls = self.drawCorridor(self.rm1P3a,self.rm1P4a,self.rm2P7b,
                              self.rm2P8b,self.rm1P3b,self.rm1P4b,
                              self.rm2P7a,self.rm2P8a)


        return (room1Walls+room2Walls+room3Walls+room4Walls+
                cor1Walls+cor2Walls+cor3Walls+cor4Walls)


    def drawCurrentRoom(self):
        if self.agentLocale == 1:
            self.drawRoom(self.rm1P1,self.rm1P2,self.rm1P3,self.rm1P4,
                                   self.rm1P3a,self.rm1P3b,self.rm1P4a,
                                   self.rm1P4b,self.rm1P5,self.rm1P6,
                                   self.rm1P5a,self.rm1P5b,self.rm1P6a,
                                   self.rm1P6b,self.rm1P7,self.rm1P8)
            if self.rm1Object == "pyr1":
                self.drawPyramid()
            else: print "room 1 object wrong in drawCurrentRoom"

        elif self.agentLocale == 2:
            self.drawRoom(self.rm2P3,self.rm2P4,self.rm2P5,self.rm2P6,
                                   self.rm2P5a,self.rm2P5b,self.rm2P6a,
                                   self.rm2P6b,self.rm2P7,self.rm2P8,
                                   self.rm2P7a,self.rm2P7b,self.rm2P8a,
                                   self.rm2P8b,self.rm2P1,self.rm2P2)
            if self.rm2Object == "stal1":
                 self.drawStalactite()
            else: print "room 2 object wrong in drawCurrentRoom"

        elif self.agentLocale == 3:
            room3Walls = self.drawRoom(self.rm3P5,self.rm3P6,self.rm3P7,
                                   self.rm3P8,
                                   self.rm3P7a,self.rm3P7b,self.rm3P8a,
                                   self.rm3P8b,self.rm3P1,self.rm3P2,
                                   self.rm3P1a,self.rm3P1b,self.rm3P2a,
                                   self.rm3P2b,self.rm3P3,self.rm3P4) 
            if self.rm3Object == "stal2":
                 self.drawStalactite2()
            else: print "room 2 object wrong in drawCurrentRoom"

        elif self.agentLocale == 4:
            room4Walls = self.drawRoom(self.rm4P7,self.rm4P8,self.rm4P1,
                                    self.rm4P2,
                                    self.rm4P1a,self.rm4P1b,self.rm4P2a,
                                    self.rm4P2b,self.rm4P3,self.rm4P4,
                                    self.rm4P3a,self.rm4P3b,self.rm4P4a,
                                    self.rm4P4b,self.rm4P5,self.rm4P6) 
            if self.rm4Object == "pyr2":
                self.drawPyramid2()
            else: print "room 4 object wrong in drawCurrentRoom"

        elif self.agentLocale == 5:
            self.drawCorridor(self.rm1P3a,self.rm1P4a,self.rm2P7b,
                              self.rm2P8b,self.rm1P3b,self.rm1P4b,
                              self.rm2P7a,self.rm2P8a)

        elif self.agentLocale == 6:
            self.drawCorridor(self.rm2P5a,self.rm2P6a,self.rm3P1b,
                              self.rm3P2b,self.rm2P5b,self.rm2P6b,
                              self.rm3P1a,self.rm3P2a)

        elif self.agentLocale == 7:
            self.drawCorridor(self.rm3P7a,self.rm3P8a,self.rm4P3b,
                              self.rm4P4b,self.rm3P7b,self.rm3P8b,
                              self.rm4P3a,self.rm4P4a)

        elif self.agentLocale == 8:
            self.drawCorridor(self.rm4P1a,self.rm4P2a,self.rm1P5b,
                              self.rm1P6b,self.rm4P1b,self.rm4P2b,
                              self.rm1P5a,self.rm1P6a)



        else:
            print "error in agentLocale ", self.agentLocale


    def drawFace(self,point1,point2,point3,fc):
        #translate to camera = 0,0,0 coordinates
        p1 = point1-self.camera
        p2 = point2-self.camera
        p3 = point3-self.camera

        #rotate 
        p1 = np.dot(self.translationMatrix,p1)
        p2 = np.dot(self.translationMatrix,p2)
        p3 = np.dot(self.translationMatrix,p3)

        #print 'go', p1,p2,p3,self.camera

        #project onto 2D
        fovealLength = 200 #this makes the triangles look odd at the edges.

        if (p1[2] == 0): p1[2] = 0.01
        if (p2[2] == 0): p2[2] = 0.01
        if (p3[2] == 0): p3[2] = 0.01

        distP1 = fovealLength/p1[2]
        distP2 = fovealLength/p2[2]
        distP3 = fovealLength/p3[2]

        #clip faces behind you
        if (distP1 < 0) and (distP2 < 0) and (distP3 < 0):
            return

        behindPerspectiveConstant = 5
        if (distP1 > 0): p1 = p1*distP1
        else: p1 = p1*behindPerspectiveConstant
        if (distP2 > 0): p2 = p2*distP2
        else: p2 = p2*behindPerspectiveConstant
        if (distP3 > 0): p3 = p3*distP3
        else: p3 = p3*behindPerspectiveConstant
        
        #move to the centre of the picture
        offset = np.array([250,250,0,0])
        p1=p1 + offset
        p2=p2 + offset
        p3=p3 + offset

        points = [p1[0], p1[1],p2[0], p2[1], p3[0], p3[1]]

        #triangle = self.canvas.create_polygon(points, outline='gray', 
        triangle = self.canvas.create_polygon(points, outline=fc, 
                                              fill=fc, width=2)
        return triangle
        
    def drawPyramid(self):
        withColour = False
        if withColour:
            self.triangle1 = self.drawFace(self.pyrP1,self.pyrP2, self.pyrP5,
                                      'red')
            self.triangle2 = self.drawFace(self.pyrP2,self.pyrP3, self.pyrP5,
                                      'green')
            self.triangle3 = self.drawFace(self.pyrP3,self.pyrP4, self.pyrP5,
                                       'blue')
            self.triangle4 = self.drawFace(self.pyrP4,self.pyrP1, self.pyrP5,
                                       'yellow')
        else:
            colour = myBlue
            self.triangle1 = self.drawFace(self.pyrP1,self.pyrP2, self.pyrP5,
                                      colour)
            self.triangle2 = self.drawFace(self.pyrP2,self.pyrP3, self.pyrP5,
                                      colour)
            self.triangle3 = self.drawFace(self.pyrP3,self.pyrP4, self.pyrP5,
                                      colour)
            self.triangle4 = self.drawFace(self.pyrP4,self.pyrP1, self.pyrP5,
                                      colour)

        
    def drawPyramid2(self):
       colr = myRed
       self.p2t1 = self.drawFace(self.pyr2P1,self.pyr2P2,self.pyr2P5,colr)
       self.p2t2 = self.drawFace(self.pyr2P2,self.pyr2P3, self.pyr2P5,colr)
       self.p2t3 = self.drawFace(self.pyr2P3,self.pyr2P4, self.pyr2P5,colr)
       self.p2t4 = self.drawFace(self.pyr2P4,self.pyr2P1, self.pyr2P5,colr)

        
    def drawStalactite2(self):
        colr = myBlue
        self.s2t1 = self.drawFace(self.stal2P1,self.stal2P2, self.stal2P5,colr)
        self.s2t2 = self.drawFace(self.stal2P2,self.stal2P3, self.stal2P5,colr)
        self.s2t3 = self.drawFace(self.stal2P3,self.stal2P4, self.stal2P5,colr)
        self.s2t4 = self.drawFace(self.stal2P4,self.stal2P1, self.stal2P5,colr)
        
    def drawStalactite(self):
       colr = myRed
       self.triangle1 = self.drawFace(self.stalP1,self.stalP2, self.stalP5,colr)
       self.triangle2 = self.drawFace(self.stalP2,self.stalP3, self.stalP5,colr)
       self.triangle3 = self.drawFace(self.stalP3,self.stalP4, self.stalP5,colr)
       self.triangle4 = self.drawFace(self.stalP4,self.stalP1, self.stalP5,colr)

        
    #return 0 for illegal position, 1,2,3,4 for room, 5,6,7,8 for corridors
    def inside(self,newCamera):
        #print newCamera[0],newCamera[2]
        #in pyramid in room1
        #if ((newCamera[0]>=self.pyrP1[0]) and (newCamera[0]<=self.pyrP3[0]) and
        #   (newCamera[2]>= self.pyrP1[2]) and (newCamera[2] <= self.pyrP3[2])):
        if ((newCamera[0]>=self.pyr1BumpP1[0]) and 
            (newCamera[0]<=self.pyr1BumpP3[0]) and
            (newCamera[2]>= self.pyr1BumpP1[2]) and 
            (newCamera[2] <= self.pyr1BumpP3[2])):
            return 0
        #in pyramid2
        #if((newCamera[0]>=self.pyr2P1[0])and (newCamera[0]<=self.pyr2P3[0]) and
        #   (newCamera[2]>=self.pyr2P1[2])and (newCamera[2] <= self.pyr2P3[2])):
        if ((newCamera[0]>=self.pyr2BumpP1[0]) and 
            (newCamera[0]<=self.pyr2BumpP3[0]) and
            (newCamera[2]>= self.pyr2BumpP1[2]) and 
            (newCamera[2] <= self.pyr2BumpP3[2])):
            return 0
        #in stalactite 1
        #if ((newCamera[0]>=self.stalP1[0])and(newCamera[0]<= self.stalP3[0])and
        #    (newCamera[2]>=self.stalP1[2])and(newCamera[2]<= self.stalP3[2])):
        if ((newCamera[0]>=self.stal1BumpP1[0]) and 
            (newCamera[0]<=self.stal1BumpP3[0]) and
            (newCamera[2]>= self.stal1BumpP1[2]) and 
            (newCamera[2] <= self.stal1BumpP3[2])):
            return 0
        #in stalactite 2
        #if((newCamera[0]>=self.stal2P1[0])and(newCamera[0]<=self.stal2P3[0])and
        #    (newCamera[2]>=self.stal2P1[2])and(newCamera[2]<=self.stal2P3[2])):
        if ((newCamera[0]>=self.stal2BumpP1[0]) and 
            (newCamera[0]<=self.stal2BumpP3[0]) and
            (newCamera[2]>= self.stal2BumpP1[2]) and 
            (newCamera[2] <= self.stal2BumpP3[2])):
            return 0
        if (newCamera[0] <= 0):         #left of all rooms
            return 0
        if (newCamera[0] >= 3000):      #right of all rooms
            return 0
        if (newCamera[2] <= 0):         #below all rooms
            return 0
        if (newCamera[2] >= 3000):      #above all rooms
            return 0

        #in room 1
        if ((newCamera[0] >= 0) and (newCamera[0] <= 1000) and 
            (newCamera[2] >= 0) and (newCamera[2] <= 1000)):      
            return 1
        #in room 2
        if ((newCamera[0] >= 0) and (newCamera[0] <= 1000) and 
            (newCamera[2] >= 2000) and (newCamera[2] <= 3000)):      
            return 2
        #in room 3
        if ((newCamera[0] >= 2000) and (newCamera[0] <= 3000) and 
            (newCamera[2] >= 2000) and (newCamera[2] <= 3000)):      
            return 3
        #in room 4
        if ((newCamera[0] >= 2000) and (newCamera[0] <= 3000) and 
            (newCamera[2] >= 0) and (newCamera[2] <= 1000)):      
            return 4

        #in corr 1
        if ((newCamera[0] >= 400) and (newCamera[0] <= 600) and 
            (newCamera[2] >= 1000) and (newCamera[2] <= 2000)):      
            return 5

        #in corr 2
        if ((newCamera[0] >= 1000) and (newCamera[0] <= 2000) and 
            (newCamera[2] >= 2400) and (newCamera[2] <= 2600)):      
            return 6

        #in corr 3
        if ((newCamera[0] >= 2400) and (newCamera[0] <= 2600) and 
            (newCamera[2] >= 1000) and (newCamera[2] <= 2000)):      
            return 7

        #in corr 4
        if ((newCamera[0] >= 1000) and (newCamera[0] <= 2000) and 
            (newCamera[2] >= 400) and (newCamera[2] <= 600)):      
            return 8
        return 0

        
    #-----Functions for moving
    def printPosition(self):
        print (self.direction, self.camera[0], self.camera[2])

    def move (self, tempCamera,distance):
        tempCamera[2] += distance * math.cos(self.direction)
        tempCamera[0] += distance * -math.sin(self.direction)
        return tempCamera

    def moveForward(self):
        print ("move forward")
        temp = np.array(self.camera)
        temp = self.move(temp,25)
        insideCheck = self.inside(temp)
        if (insideCheck == 0):
            print ("bump")
            if (fUseSpikeServer):
                self.toSpinQ.sendBump()
            return
        else: self.agentLocale = insideCheck

        self.camera = temp
        self.reDraw()
        self.printPosition()

    def moveBack(self):
        print ("move back")
        temp = np.array(self.camera)
        temp = self.move(temp,-47)
        insideCheck = self.inside(temp)
        if (insideCheck == 0):
            print ("bump back")
            #if (fUseSpikeServer):
            #    self.toSpinQ.sendSingleSpike(0x00000816)
            return
        else: self.agentLocale = insideCheck

        self.camera = temp
        self.reDraw()
        self.printPosition()

    def setRotation(self):
        self.translationMatrix[0,0] = math.cos(self.direction)
        self.translationMatrix[0,2] = math.sin(self.direction)
        self.translationMatrix[2,0] = -math.sin(self.direction)
        self.translationMatrix[2,2] = math.cos(self.direction)
        #print (self.direction )

    def turnRight (self):
        print ("turn right")
        self.direction -= 0.19
        self.direction = self.direction % 6.28
        self.setRotation()
        self.reDraw()
        self.printPosition()

    def turnLeft (self):
        print ("turn left")
        self.direction += 0.17
        self.direction = self.direction % 6.28
        self.setRotation()
        self.reDraw()
        self.printPosition()

    def reset(self):
        #undone teleport
        print "teleport"
        #self.agentLocale = 3
        #self.direction = 3.1
        #self.camera = np.array([2500.0,300.0,2026.0,1.0]) 
        self.agentLocale = 4
        self.direction = 3.1
        #self.camera = np.array([2500.0,300.0,899.0,1.0]) 
        self.camera = np.array([2500.0,300.0,1099.0,1.0]) 

        #self.direction = 0.0
        #self.camera = np.array([150.0,300.0,0.0,1.0])
        self.reDraw()


    def keyHandler(self,event):
        #print "keyhandler", repr(event.char)
        if (event.char == '\r'):
            text = self.editBox.get(1.0,END)
            self.editBox.delete(1.0,END)
            self.processTextInput(text)
            self.putTextInFile(text)

    def initUI(self):
        self.parent.title("CABot Environment")        
        self.pack(fill=BOTH, expand=1)

        self.canvas = Canvas(self)

        self.walls = self.drawWalls()
        self.drawPyramid()
        self.drawPyramid2()
        self.drawStalactite()
        self.drawStalactite2()
 
        self.canvas.pack(fill=BOTH, expand=1)

        quitButton = Button(self, text="Quit",
            command=self.quit)
        quitButton.place(x=0, y=0)

        forwardButton = Button(self, text="Forward", command=self.moveForward)
        #forwardButton = Button(self, text="Forward", command=self.forward)
        forwardButton.place(x=70, y=0)
        backButton = Button(self, text="Back", command=self.moveBack)
        #backButton = Button(self, text="Back", command=self.back)
        backButton.place(x=140, y=0)
        leftButton = Button(self, text="Left", command=self.turnLeft)
        #leftButton = Button(self, text="Left", command=self.left)
        leftButton.place(x=210, y=0)
        rightButton = Button(self, text="Right", command=self.turnRight)
        #rightButton = Button(self, text="Right", command=self.right)
        rightButton.place(x=280, y=0)
        resetButton = Button(self, text="Reset", command=self.reset)
        resetButton.place(x=350, y=0)
        
        if (fUseSpikeServer):
            printButton = Button(self, text="Print", command=self.dumpBinCount)
        else:
            #printButton = Button(self, text="Print", command=self.dumpJPG)
            printButton = Button(self, text="Print", command=self.testPixels)
        printButton.place(x=420, y=0)
        self.editBox = Text(self,height=1, width=50)
        self.editBox.place(x=0, y=25)
        self.editBox.bind("<Key>",self.keyHandler)

        self.reDraw()

        if (fUseSpikeServer):
            #printButton.after(1000,self.readFromSpin) #setup a timer callback
            printButton.after(100,self.writePictureToSpin) 

def main():
    root = Tk()
    env = Environment(root)
    if (fUseSpikeServer):
        env.toSpinQ = spikeQueue()
        env.imageTranslator = imageToPixelClass(INPSIZE)
    else:
        env.imageTranslator = imageToPixelClass(50) # for testPixels

    root.geometry("500x500+300+300")
    root.mainloop()  


if __name__ == '__main__':
    main()  
