"""
This one gets the pixels from red, green, and blue, and
returns whether one of those is on. It also returns a 20x20 input for each
of those colours written onto the same processor.
"""
from PIL import Image
import numpy 

class imageToPixelClass:

    def __init__(self,inpSize):
        self.inpSize = inpSize

    def test(self):
        print "iTPC"

    def getColourPixelsFromFile(self,imageFileName,colour,outSize):
        inputMatrix = numpy.zeros((outSize,outSize))
        for inpRow in range (0,outSize):
            for inpCol in range (0,outSize):
                rgb = self.pixels[inpCol,inpRow]
                if (colour == 'blue'):
                    inputMatrix[inpCol,inpRow] = rgb[2]
                elif (colour == 'red'):
                    inputMatrix[inpCol,inpRow] = rgb[0]
                elif (colour == 'green'):
                    inputMatrix[inpCol,inpRow] = rgb[1]
                else:
                    print "bad colour in getColourPixelsFromFile"

        ##set result image array
        resultImage = numpy.zeros((outSize,outSize))
        THRESHOLD = 240
        #THRESHOLD = 128
        resultImageArray = [] 
        for outRow in range (outSize):
            for outColumn in range (0,outSize):
                if inputMatrix[outColumn,outRow] > THRESHOLD :
                    #print outRow, outColumn
                    pixelOn = (outRow*outSize)+outColumn
                    resultImageArray = resultImageArray + [pixelOn]

        return resultImageArray
        

    def getBluePixelsFromFile(self,imageFileName):
        #print "blue "

        ##get the blue pixels
        inputMatrix = numpy.zeros((self.inpSize,self.inpSize))
        for inpRow in range (0,self.inpSize):
            for inpCol in range (0,self.inpSize):
                rgb = self.pixels[inpCol,inpRow]
                inputMatrix[inpCol,inpRow] = rgb[2]

        ##set result image array
        resultImage = numpy.zeros((self.inpSize,self.inpSize))
        THRESHOLD = 240
        resultImageArray = [] 
        for outRow in range (0,self.inpSize):
            for outColumn in range (0,self.inpSize):
                if inputMatrix[outColumn,outRow] > THRESHOLD :
                    #print outRow, outColumn
                    pixelOn = (outRow*self.inpSize)+outColumn
                    resultImageArray = resultImageArray + [pixelOn]

        return resultImageArray
        

    def getRedPixelsFromFile(self,imageFileName):
        #print "red"

        ##get the red pixels
        inputMatrix = numpy.zeros((self.inpSize,self.inpSize))
        for inpRow in range (0,self.inpSize):
            for inpCol in range (0,self.inpSize):
                rgb = self.pixels[inpCol,inpRow]
                #print rgb,inpRow,inpCol
                inputMatrix[inpCol,inpRow] = rgb[0]

        ##set result image array
        resultImage = numpy.zeros((self.inpSize,self.inpSize))
        THRESHOLD = 240
        resultImageArray = [] 
        for outRow in range (0,self.inpSize):
            for outColumn in range (0,self.inpSize):
                if inputMatrix[outColumn,outRow] > THRESHOLD :
                    #print outRow, outColumn
                    pixelOn = (outRow*self.inpSize)+outColumn
                    resultImageArray = resultImageArray + [pixelOn]
        return resultImageArray

    def getGreenPixelsFromFile(self,imageFileName):
        #print "green"

        ##get the green pixels
        inputMatrix = numpy.zeros((self.inpSize,self.inpSize))
        for inpRow in range (0,self.inpSize):
            for inpCol in range (0,self.inpSize):
                rgb = self.pixels[inpCol,inpRow]
                inputMatrix[inpCol,inpRow] = rgb[1]

        ##set result image array
        resultImage = numpy.zeros((self.inpSize,self.inpSize))
        THRESHOLD = 240
        resultImageArray = [] 
        for outRow in range (0,self.inpSize):
            for outColumn in range (0,self.inpSize):
                if inputMatrix[outColumn,outRow] > THRESHOLD :
                    #print outRow, outColumn
                    pixelOn = (outRow*self.inpSize)+outColumn
                    resultImageArray = resultImageArray + [pixelOn]
        return resultImageArray
        

    def convertColourPixelsToOutput(self,colourPixels,colour):
        if (colour == 'red'):
            pixelOffset = 0;
        elif (colour == 'green'):
            pixelOffset = 400;
        elif (colour == 'blue'):
            pixelOffset = 800;
        else:
            print "bad colour in convertColourPixelsToOutput"
        #colourInputPrefix = 0x000038*256

        result = []
        for pixelNum in colourPixels:
            #result = result + [colourInputPrefix +pixelOffset+ pixelNum]
            result = result + [pixelOffset+ pixelNum]
            
        #print colourPixels
        return result

    def getPixelsFromFile(self,imageFileName):
        try: 
            im = Image.open(imageFileName)  
        except:
            print "fail to open image getPixelsClass"

        im = im.crop((0,0,380,380))

        #get the bw bits
        #shrink it 
        size = (self.inpSize,self.inpSize)
        im.thumbnail(size)

        #get the pixels
        self.pixels = im.load()

        #blueResultImageArray = self.getBluePixelsFromFile(imageFileName)
        redResultImageArray = self.getRedPixelsFromFile(imageFileName)
        greenRIA = self.getGreenPixelsFromFile(imageFileName)
        blueResultImageArray = self.getColourPixelsFromFile(imageFileName,
            'blue',self.inpSize)
        redResultImageArray = self.getColourPixelsFromFile(imageFileName,
            'red',self.inpSize)
        greenRIA = self.getColourPixelsFromFile(imageFileName,
            'green',self.inpSize)

        resultImageArray = blueResultImageArray + redResultImageArray + greenRIA
        

        #Colour is always 20x20 input
        size = (20,20)
        im.thumbnail(size)
        #reload pixels
        self.pixels = im.load()

        blueResultImageArray = self.getColourPixelsFromFile(imageFileName,
            'blue',20)
        blueResult = self.convertColourPixelsToOutput(blueResultImageArray,
            'blue')
        redResultImageArray = self.getColourPixelsFromFile(imageFileName,
            'red',20)
        redResult = self.convertColourPixelsToOutput(redResultImageArray,
            'red')
        greenRIA = self.getColourPixelsFromFile(imageFileName,
            'green',20)
        greenResult = self.convertColourPixelsToOutput(greenRIA,
            'green')

        #print resultHexArray
        #return resultHexArray + greenResult + redResult + blueResult

        return [resultImageArray]+ [greenResult + redResult + blueResult]

