"""
Expect a picture every 10 ticks.
Keep the most recent sentence, and add it in a word at a time every
50 ticks.
"""

from spinnman.messages.eieio.eieio_header import EIEIOHeader
from spinnman.messages.eieio.eieio_message import EIEIOMessage
from spinnman.messages.eieio.eieio_type_param import EIEIOTypeParam
from spinnman.messages.eieio.eieio_prefix_type import EIEIOPrefixType
from spynnaker.pyNN.utilities.conf import config
from spinnman.connections.udp_packet_connections.reverse_iptag_connection \
    import ReverseIPTagConnection

import time as t


class spikeQueue:

    def __init__(self):
        print "new q"
        self.key = 0x70800
        self.bwVisionKey = 0x90800
        self.colourVisionKey = 0x50800
        self.udp_connection = \
            ReverseIPTagConnection(remote_host="192.168.1.1",remote_port=12345)
        self.bwudp_connection = \
            ReverseIPTagConnection(remote_host="192.168.1.1",remote_port=12346)
        self.colourudp_connection = \
            ReverseIPTagConnection(remote_host="192.168.1.1",remote_port=12347)

        #init sentence variables
        self.currentSentenceLeft = 0
        self.currentPosInSent = 0

    def sendWord(self):
        if self.currentSentenceLeft == 0:
            return
        header = EIEIOHeader(type_param=EIEIOTypeParam.KEY_32_BIT)
        message = EIEIOMessage(eieio_header=header, data=bytearray())

        print "sw ", self.currentSentence[self.currentPosInSent]

        mess = self.key+self.currentSentence[self.currentPosInSent]
        message.write_data(mess)
        self.udp_connection.send_eieio_message(message)

        t.sleep(0.01)

        self.currentPosInSent += 1
        self.currentSentenceLeft -= 1
        return

    def writeBWPicture(self,wordArray,length):
        if (length == 0):
            return
        #undone We could send one message with all the data instead
        #of one for each pixel.
        header = EIEIOHeader(type_param=EIEIOTypeParam.KEY_32_BIT)
        for i in range (0,length):
            bwmessage = EIEIOMessage(eieio_header=header, data=bytearray())
            bwVisionMessage = self.bwVisionKey + wordArray[i]
            #print "b", bwVisionMessage, wordArray[i]
            
            bwmessage.write_data(bwVisionMessage)
            self.bwudp_connection.send_eieio_message(bwmessage)

        #t.sleep(0.005)
        return

    def writeColourPicture(self,wordArray,length):
        header = EIEIOHeader(type_param=EIEIOTypeParam.KEY_32_BIT)
        for i in range (0,length):
            colourMessage = EIEIOMessage(eieio_header=header, data=bytearray())
            colourVisionMessage = self.colourVisionKey + wordArray[i]
            #print "c", colourVisionMessage, wordArray[i]
    
            colourMessage.write_data(colourVisionMessage)
            self.colourudp_connection.send_eieio_message(colourMessage)

        #t.sleep(0.005)
        return

    def writeSentence(self,sentence,length):
        print sentence
        if self.currentSentenceLeft == 0:
            self.currentPosInSent = 0
            self.currentSentenceLeft = length
            self.currentSentence = sentence
        else:
            print "trying to parse new sentence while parsing"

    def sendBump(self):
        print "toss bump"
        header = EIEIOHeader(type_param=EIEIOTypeParam.KEY_32_BIT)
        message = EIEIOMessage(eieio_header=header, data=bytearray())

        mess = self.key+22
        message.write_data(mess)
        self.udp_connection.send_eieio_message(message)




